#include <vector>

#ifndef MATRIX_HPP
#define MATRIX_HPP

typedef std::vector<int> Column;
typedef std::vector<int> Row;

class DMatrix
{
  unsigned m_uiXDim;
  unsigned m_uiYDim;

  std::vector<Column> m_cMatrix;

  //Private Funktionen
  int NextPerm(int* piPerm, int iSize); //OK - tested
  DMatrix* DoPermutation(int* piPerm);  //OK - tested
public:
  //Konstruktoren
  DMatrix();  //Leere Matrix
  DMatrix(DMatrix &); //Copy Constructor
  DMatrix(unsigned uiXDim, unsigned uiYDim); //OK - tested

  //Destruktor
  ~DMatrix();   //OK - tested

  //Zugriff auf die Groesse
  unsigned GetXDim();  //OK
  unsigned GetYDim();  //OK

  //Zugriff auf Elemente
  int    SetRow(unsigned uiY, Row    cRow     );  //OK - tested
  int    SetCol(unsigned uiX, Column cCol     );  //OK - tested
  Row    GetRow(unsigned uiY, int&   iRetValue);  //OK - tested
  Column GetCol(unsigned uiX, int&   iRetValue);  //OK - tested
  Row    GetRow(unsigned uiY, int&   iRetValue, Row& rcRow); //OK - tested
  Column GetCol(unsigned uiX, int&   iRetValue, Column& rcCol); //OK - tested
  int    SetElem(unsigned uiX, unsigned uiY, int iValue);  //OK - tested
  int    GetElem(unsigned uiX, unsigned uiY, int& iValue); //OK

  //Alle Permutationen erzeugen
  std::vector<DMatrix*> PermuteAll(int& riError); //OK - tested
  DMatrix* Permute();  //OK - tested

  //Manipulationen an der Groesse
  int Init(unsigned uiXDim, unsigned uiYDim);  //OK
  int InsertCol(unsigned uiX, Column pdCol); //OK - tested
  int InsertRow(unsigned uiY, Row pcRow); //OK - tested
  int RemoveCol(unsigned uiX);  //OK - tested
  int RemoveRow(unsigned uiY);  //OK - tested

  //Die Zeilen werden aneinandergehaengt
  int ConcatRows(DMatrix &); //OK - tested
  //Die Spalten werden aneinandergehaengt
  int ConcatCols(DMatrix &); //OK - tested

  //Arithmetische Operationen
  int AddSka(int iValue);  //OK - tested
  int MulSka(int iValue);  //OK - tested

  //Sonstiges
  void Show();  //OK - tested
};

#define GENERIC_ERROR       -1
#define INDEX_OUT_OF_BOUNDS -2
#define MATRIX_INVALID      -3
#define INVALID_SIZE        -4

#endif
