/***************************************************************************
 *   Copyright (C) 2007 by Martin Apel,,,   *
 *   kermit@frog   *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef GAS_H
#define GAS_H

/**
	@author Martin Apel,,, <kermit@frog>
*/

#include <set>

#include "Matrix.hpp"

typedef std::set<unsigned> SubSet;

class GAS
{
  //Minimal qualified set
  std::set<SubSet> m_G0;

  bool IsSubSet(const SubSet& sSet1, const SubSet& sSet2);    //tested
  bool IsSubSetEq(const SubSet& sSet1, const SubSet& sSet2);  //tested

  std::set<SubSet> BuildMaxForbidden();
  void AddToMaxForbidden(std::set<SubSet>& FM, SubSet sSet);

  unsigned Max(const SubSet& sSet);
  unsigned Max(const std::set<SubSet>& sSet);
public:
  GAS();
  GAS(GAS& g);    //Copyconstructor
  ~GAS();

  int AddQualifiedSet(SubSet vSet);  //tested
  void Clear();                       //tested

  DMatrix* GetCA();

  unsigned GetUser();
  int Check();

  //Testing and Debugging
  void Print(const SubSet& sSet);
  void Print(const std::set<SubSet>& sSet);
  void Print(DMatrix* matrix);
  void Test();
};

#endif
