/***************************************************************************
 *   Copyright (C) 2007 by Martin Apel,,,                                  *
 *   kermit@frog                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/
#ifndef KAUSN_H
#define KAUSN_H

/**
	@author Martin Apel,,, <kermit@frog>
*/

#include "vcryptscheme.h"
#include <set>
typedef std::set<unsigned> SubSet;
//k aus n - as described by Stefan Droste
class KausN : public VCryptScheme
{
  void Add(unsigned p, DMatrix** S);
  bool FindUnbalanced(DMatrix* S0, DMatrix* S1, std::set<unsigned>& sS0Matched, std::set<unsigned>& sS1Matched,
                      bool& bS0, unsigned& uiOnesRet);
  bool Matched(const Column& c1, const Column& c2);
  bool NextCol(Column& S);
  bool NextBitString(Column& cCol, unsigned& uiOnes);
protected:
  const unsigned m_uiNeeded;  //k

  void CreateBaseMatrices();

public:
    KausN(unsigned k, unsigned n);

    ~KausN();

  void Print(SubSet& sSet);
};

#endif
