/***************************************************************************
 *   Copyright (C) 2007 by Martin Apel,,,                                  *
 *   kermit@frog                                                           *
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 *   This program is distributed in the hope that it will be useful,       *
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
 *   GNU General Public License for more details.                          *
 *                                                                         *
 *   You should have received a copy of the GNU General Public License     *
 *   along with this program; if not, write to the                         *
 *   Free Software Foundation, Inc.,                                       *
 *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
 ***************************************************************************/


#ifndef VISCRYPT_H
#define VISCRYPT_H

#include <QMainWindow>
#include <QCloseEvent>
#include <QtGui>

#include "imposergui.h"
#include "nausngui.h"
#include "kausngui.h"
#include "gasgui.h"

class QAction;
class QMenu;

class VisCrypt:public QMainWindow
{
  Q_OBJECT

public:
  VisCrypt();
  ~VisCrypt();

private slots:
  void SuperImpose();
  void About();
  void KausK();
  void KausN();
  void Gas();

private:
  void CreateActions();
  void CreateMenus();

  QLabel*  pcLeinwand;

  QMenu*   fileMenu;
  QMenu*   helpMenu;
  QAction* exitAct;
  QAction* aboutAct;
  QAction* aboutQtAct;

  QAction* kauskAct;
  QAction* kausnAct;
  QAction* gasAct;
  QAction* superImposeAct;
  //Dialoge
  ImposerGUI cImposeGui;
  NausNGUI   cNausNGui;
  KausNGUI   cKausNGui;
  GasGUI     cGasGui;
};

#endif
